Index: LMDZ5/branches/testing/libf/phylmd/cva_driver.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cva_driver.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/cva_driver.F90	(revision 2298)
@@ -2,7 +2,9 @@
 ! $Id$
 
-SUBROUTINE cva_driver(len, nd, ndp1, ntra, nloc, &
+SUBROUTINE cva_driver(len, nd, ndp1, ntra, nloc, k_upper, &
                       iflag_con, iflag_mix, iflag_ice_thermo, iflag_clos, ok_conserv_q, &
-                      delt, t1, q1, qs1, t1_wake, q1_wake, qs1_wake, s1_wake, &
+!!                      delt, t1, q1, qs1, t1_wake, q1_wake, qs1_wake, s1_wake, &  ! jyg
+                      delt, comp_threshold, &                                      ! jyg
+                      t1, q1, qs1, t1_wake, q1_wake, qs1_wake, s1_wake, &          ! jyg
                       u1, v1, tra1, &
                       p1, ph1, &
@@ -19,5 +21,5 @@
                       ftd1, fqd1, &
                       Plim11, Plim21, asupmax1, supmax01, asupmaxmin1, &
-                      lalim_conv, & 
+                      lalim_conv1, & 
 !!                      da1,phi1,mp1,phi21,d1a1,dam1,sigij1,clw1, &        ! RomP
 !!                      elij1,evap1,ep1,epmlmMm1,eplaMm1, &                ! RomP
@@ -52,4 +54,6 @@
 ! ndp1          Integer        Input        nd + 1
 ! ntra          Integer        Input        number of tracors
+! nloc          Integer        Input        dimension of arrays for compressed fields
+! k_upper       Integer        Input        upmost level for vertical loops
 ! iflag_con     Integer        Input        version of convect (3/4)
 ! iflag_mix     Integer        Input        version of mixing  (0/1/2)
@@ -60,4 +64,6 @@
 ! ok_conserv_q  Logical        Input        when true corrections for water conservation are swtiched on
 ! delt          Real           Input        time step
+! comp_threshold Real           Input       threshold on the fraction of convective points below which
+!                                            fields  are compressed
 ! t1            Real           Input        temperature (sat draught envt)
 ! q1            Real           Input        specific hum (sat draught envt)
@@ -156,67 +162,72 @@
   include 'iniprint.h'
 
-
 ! Input
-  INTEGER len
-  INTEGER nd
-  INTEGER ndp1
-  INTEGER ntra
-  INTEGER iflag_con
-  INTEGER iflag_mix
-  INTEGER iflag_ice_thermo
-  INTEGER iflag_clos
-  LOGICAL ok_conserv_q
-  REAL tau_cld_cv
-  REAL coefw_cld_cv
-  REAL delt
-  REAL t1(len, nd)
-  REAL q1(len, nd)
-  REAL qs1(len, nd)
-  REAL t1_wake(len, nd)
-  REAL q1_wake(len, nd)
-  REAL qs1_wake(len, nd)
-  REAL s1_wake(len)
-  REAL u1(len, nd)
-  REAL v1(len, nd)
-  REAL tra1(len, nd, ntra)
-  REAL p1(len, nd)
-  REAL ph1(len, ndp1)
-  REAL Ale1(len)
-  REAL Alp1(len)
-  REAL omega1(len,nd)
-  REAL sig1feed1 ! pressure at lower bound of feeding layer
-  REAL sig2feed1 ! pressure at upper bound of feeding layer
-  REAL wght1(nd) ! weight density determining the feeding mixture
+  INTEGER, INTENT (IN)                               :: len
+  INTEGER, INTENT (IN)                               :: nd
+  INTEGER, INTENT (IN)                               :: ndp1
+  INTEGER, INTENT (IN)                               :: ntra
+  INTEGER, INTENT(IN)                                :: nloc ! (nloc=klon)  pour l'instant
+  INTEGER, INTENT (IN)                               :: k_upper
+  INTEGER, INTENT (IN)                               :: iflag_con
+  INTEGER, INTENT (IN)                               :: iflag_mix
+  INTEGER, INTENT (IN)                               :: iflag_ice_thermo
+  INTEGER, INTENT (IN)                               :: iflag_clos
+  LOGICAL, INTENT (IN)                               :: ok_conserv_q
+  REAL, INTENT (IN)                                  :: tau_cld_cv
+  REAL, INTENT (IN)                                  :: coefw_cld_cv
+  REAL, INTENT (IN)                                  :: delt
+  REAL, INTENT (IN)                                  :: comp_threshold
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: t1
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: q1
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: qs1
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: t1_wake
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: q1_wake
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: qs1_wake
+  REAL, DIMENSION (len), INTENT (IN)                 :: s1_wake
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: u1
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: v1
+  REAL, DIMENSION (len, nd, ntra), INTENT (IN)       :: tra1
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: p1
+  REAL, DIMENSION (len, ndp1), INTENT (IN)           :: ph1
+  REAL, DIMENSION (len), INTENT (IN)                 :: Ale1
+  REAL, DIMENSION (len), INTENT (IN)                 :: Alp1
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: omega1
+  REAL, INTENT (IN)                                  :: sig1feed1 ! pressure at lower bound of feeding layer
+  REAL, INTENT (IN)                                  :: sig2feed1 ! pressure at upper bound of feeding layer
+  REAL, DIMENSION (nd), INTENT (IN)                  :: wght1     ! weight density determining the feeding mixture
+  INTEGER, DIMENSION (len), INTENT (IN)              :: lalim_conv1
+
+! Input/Output
+  REAL, DIMENSION (len, nd), INTENT (INOUT)          :: sig1
+  REAL, DIMENSION (len, nd), INTENT (INOUT)          :: w01
 
 ! Output
-  INTEGER iflag1(len)
-  REAL ft1(len, nd)
-  REAL fq1(len, nd)
-  REAL fu1(len, nd)
-  REAL fv1(len, nd)
-  REAL ftra1(len, nd, ntra)
-  REAL precip1(len)
-  INTEGER kbas1(len)
-  INTEGER ktop1(len)
-  REAL cbmf1(len)
-  REAL plcl1(klon)
-  REAL plfc1(klon)
-  REAL wbeff1(klon)
-  REAL sig1(len, klev) !input/output
-  REAL w01(len, klev) !input/output
-  REAL ptop21(len)
-  REAL sigd1(len)
-  REAL ma1(len, nd)
-  REAL mip1(len, nd)
+  INTEGER, DIMENSION (len), INTENT (OUT)             :: iflag1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: ft1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: fq1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: fu1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: fv1
+  REAL, DIMENSION (len, nd, ntra), INTENT (OUT)      :: ftra1
+  REAL, DIMENSION (len), INTENT (OUT)                :: precip1
+  INTEGER, DIMENSION (len), INTENT (OUT)             :: kbas1
+  INTEGER, DIMENSION (len), INTENT (OUT)             :: ktop1
+  REAL, DIMENSION (len), INTENT (OUT)                :: cbmf1
+  REAL, DIMENSION (len), INTENT (OUT)                :: plcl1
+  REAL, DIMENSION (len), INTENT (OUT)                :: plfc1
+  REAL, DIMENSION (len), INTENT (OUT)                :: wbeff1
+  REAL, DIMENSION (len), INTENT (OUT)                :: ptop21
+  REAL, DIMENSION (len), INTENT (OUT)                :: sigd1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: ma1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: mip1
 ! real Vprecip1(len,nd)
-  REAL vprecip1(len, nd+1)
-  REAL upwd1(len, nd)
-  REAL dnwd1(len, nd)
-  REAL dnwd01(len, nd)
-  REAL qcondc1(len, nd) ! cld
-  REAL wd1(len) ! gust
-  REAL cape1(len)
-  REAL cin1(len)
-  REAL tvp1(len, nd)
+  REAL, DIMENSION (len, ndp1), INTENT (OUT)          :: vprecip1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: upwd1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: dnwd1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: dnwd01
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: qcondc1         ! cld
+  REAL, DIMENSION (len), INTENT (OUT)                :: wd1             ! gust
+  REAL, DIMENSION (len), INTENT (OUT)                :: cape1
+  REAL, DIMENSION (len), INTENT (OUT)                :: cin1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: tvp1
 
 !AC!
@@ -224,26 +235,27 @@
 !!      real da(len,nd),phi(len,nd,nd)
 !AC!
-  REAL ftd1(len, nd)
-  REAL fqd1(len, nd)
-  REAL Plim11(len)
-  REAL Plim21(len)
-  REAL asupmax1(len, nd)
-  REAL supmax01(len)
-  REAL asupmaxmin1(len)
-  INTEGER lalim_conv(len)
-  REAL qtc1(len, nd)         ! cld
-  REAL sigt1(len, nd)        ! cld
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: ftd1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: fqd1
+  REAL, DIMENSION (len), INTENT (OUT)                :: Plim11
+  REAL, DIMENSION (len), INTENT (OUT)                :: Plim21
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: asupmax1
+  REAL, DIMENSION (len), INTENT (OUT)                :: supmax01
+  REAL, DIMENSION (len), INTENT (OUT)                :: asupmaxmin1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: qtc1            ! cld
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: sigt1           ! cld
 
 ! RomP >>>
-  REAL wdtrainA1(len, nd), wdtrainM1(len, nd)
-  REAL da1(len, nd), phi1(len, nd, nd), mp1(len, nd)
-  REAL epmlmMm1(len, nd, nd), eplaMm1(len, nd)
-  REAL evap1(len, nd), ep1(len, nd)
-  REAL sigij1(len, nd, nd), elij1(len, nd, nd)
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: wdtrainA1, wdtrainM1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: da1, mp1
+  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: phi1
+  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: epmlmMm1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: eplaMm1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: evap1, ep1
+  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: sigij1, elij1
 !JYG,RL
-  REAL wghti1(len, nd) ! final weight of the feeding layers
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: wghti1      ! final weight of the feeding layers
 !JYG,RL
-  REAL phi21(len, nd, nd)
-  REAL d1a1(len, nd), dam1(len, nd)
+  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: phi21
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: d1a1, dam1
 ! RomP <<<
 
@@ -388,4 +400,5 @@
 !$OMP THREADPRIVATE(debut)
 
+  REAL coef_convective(len)   ! = 1 for convective points, = 0 otherwise
   REAL tnk1(klon)
   REAL thnk1(klon)
@@ -426,8 +439,9 @@
 ! (local) compressed fields:
 
-  INTEGER nloc
-! parameter (nloc=klon) ! pour l'instant
 
   INTEGER idcum(nloc)
+!jyg<
+  LOGICAL compress    ! True if compression occurs
+!>jyg
   INTEGER iflag(nloc), nk(nloc), icb(nloc)
   INTEGER nent(nloc, klev)
@@ -480,6 +494,7 @@
   REAL fu(nloc, klev), fv(nloc, klev)
   REAL upwd(nloc, klev), dnwd(nloc, klev), dnwd0(nloc, klev)
-  REAL ma(nloc, klev), mip(nloc, klev), tls(nloc, klev)
-  REAL tps(nloc, klev), qprime(nloc), tprime(nloc)
+  REAL ma(nloc, klev), mip(nloc, klev)
+!!  REAL tls(nloc, klev), tps(nloc, klev)                 ! unused . jyg
+  REAL qprime(nloc), tprime(nloc)
   REAL precip(nloc)
 ! real Vprecip(nloc,klev)
@@ -547,5 +562,5 @@
 
   IF (iflag_con==3) THEN
-    CALL cv3_param(nd, delt)
+    CALL cv3_param(nd, k_upper, delt)
 
   END IF
@@ -682,5 +697,5 @@
 !   p2feed1(i)=ph1(i,3)
 !testCR: on prend la couche alim des thermiques
-!   p2feed1(i)=ph1(i,lalim_conv(i)+1)
+!   p2feed1(i)=ph1(i,lalim_conv1(i)+1)
 !   print*,'lentr=',lentr(i),ph1(i,lentr(i)+1),ph1(i,2)
   END DO
@@ -762,7 +777,12 @@
 ! =====================================================================
 
+!  Determine the number "ncum" of convective gridpoints, the list "idcum" of convective
+!  gridpoints and the weights "coef_convective" (= 1. for convective gridpoints and = 0.
+!  elsewhere).
   ncum = 0
+  coef_convective(:) = 0.
   DO i = 1, len
     IF (iflag1(i)==0) THEN
+      coef_convective(i) = 1.
       ncum = ncum + 1
       idcum(ncum) = i
@@ -782,5 +802,18 @@
 ! print*,'ncum tv1 ',ncum,tv1
 ! print*,'tvp1 ',tvp1
-      CALL cv3a_compress(len, nloc, ncum, nd, ntra, &
+!jyg<
+!   If the fraction of convective points is larger than comp_threshold, then compression
+!   is assumed useless.
+!
+  compress = ncum .lt. len*comp_threshold
+!
+  IF (.not. compress) THEN
+    DO i = 1,len
+      idcum(i) = i
+    ENDDO
+  ENDIF
+!
+!>jyg
+      CALL cv3a_compress(len, nloc, ncum, nd, ntra, compress, &
                          iflag1, nk1, icb1, icbs1, &
                          plcl1, tnk1, qnk1, gznk1, hnk1, unk1, vnk1, &
@@ -837,5 +870,4 @@
                          inb, tp, tvp, clw, hp, ep, sigp, buoy, &
                          frac)
-
     END IF
 
@@ -897,5 +929,4 @@
                            Plim1, plim2, asupmax, supmax0, &
                            asupmaxmin, cbmf, plfc, wbeff)
-
         if (prt_level >= 10) &
              PRINT *, 'cv3p1_closure-> plfc,wbeff ', plfc(1), wbeff(1)
@@ -993,5 +1024,6 @@
                      iflag, precip, vprecip, ft, fq, fu, fv, ftra, &
                      cbmf, upwd, dnwd, dnwd0, ma, mip, &
-                     tls, tps, qcondc, wd, &
+!!                     tls, tps, &                            ! useless . jyg
+                     qcondc, wd, &
                      ftd, fqd, qnk, qtc, sigt, tau_cld_cv, coefw_cld_cv)
     END IF
@@ -1035,5 +1067,5 @@
 
     IF (iflag_con==3) THEN
-      CALL cv3a_uncompress(nloc, len, ncum, nd, ntra, idcum, &
+      CALL cv3a_uncompress(nloc, len, ncum, nd, ntra, idcum, compress, &
                            iflag, icb, inb, &
                            precip, cbmf, plcl, plfc, wbeff, sig, w0, ptop2, &
@@ -1078,6 +1110,14 @@
   END IF ! ncum>0
 
+!
+! In order take into account the possibility of changing the compression,
+! reset m, sig and w0 to zero for non-convective points.
+  DO k = 1,nd-1
+        sig1(:, k) = sig1(:, k)*coef_convective(:)
+        w01(:, k)  = w01(:, k)*coef_convective(:)
+  ENDDO
+
   IF (debut) THEN
-    PRINT *, ' cv_compress -> '
+    PRINT *, ' cv_uncompress -> '
     debut = .FALSE.
   END IF  !(debut) THEN
Index: LMDZ5/branches/testing/libf/phylmd/cvltr_scav.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cvltr_scav.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/cvltr_scav.F90	(revision 2298)
@@ -122,22 +122,24 @@
   real                           :: conservMA
 
-  ! ======================================================
-  ! calcul de l'impaction
-  ! ======================================================
-
-  ! impaction sur la surface de la colonne de la descente insaturee
-  ! On prend la moyenne des precip entre le niveau i+1 et i
-  ! I=3/4* (P(1+1)+P(i))/2 / (sigd*r*rho_l)
-  ! 1000kg/m3= densite de l'eau
-  ! 0.75e-3 = 3/4 /1000
-  ! Par la suite, I est tout le temps multiplie par sig_d pour avoir l'impaction sur la surface de la maille
-  ! on le neglige ici pour simplifier le code
-
-  DO j=1,klev-1
-     DO i=1,klon
-        imp(i,j) = coefcoli_3d(i,j)*0.75e-3/rdrop *&
-             0.5*(pmflxr(i,j+1)+pmflxs(i,j+1)+pmflxr(i,j)+pmflxs(i,j))
-     ENDDO
-  ENDDO
+!jyg<
+!!  ! ======================================================
+!!  ! calcul de l'impaction
+!!  ! ======================================================
+!!
+!!  ! impaction sur la surface de la colonne de la descente insaturee
+!!  ! On prend la moyenne des precip entre le niveau i+1 et i
+!!  ! I=3/4* (P(1+1)+P(i))/2 / (sigd*r*rho_l)
+!!  ! 1000kg/m3= densite de l'eau
+!!  ! 0.75e-3 = 3/4 /1000
+!!  ! Par la suite, I est tout le temps multiplie par sig_d pour avoir l'impaction sur la surface de la maille
+!!!!  ! on le neglige ici pour simplifier le code
+!!
+!!  DO j=1,klev-1
+!!     DO i=1,klon
+!!        imp(i,j) = coefcoli_3d(i,j)*0.75e-3/rdrop *&
+!!             0.5*(pmflxr(i,j+1)+pmflxs(i,j+1)+pmflxr(i,j)+pmflxs(i,j))
+!!     ENDDO
+!!  ENDDO
+!>jyg
   !
   ! initialisation pour flux de traceurs, td et autre
@@ -237,4 +239,24 @@
   END DO
 
+!jyg<
+  ! ======================================================
+  ! calcul de l'impaction
+  ! ======================================================
+
+  ! impaction sur la surface de la colonne de la descente insaturee
+  ! On prend la moyenne des precip entre le niveau i+1 et i
+  ! I=3/4* (P(1+1)+P(i))/2 / (sigd*r*rho_l)
+  ! 1000kg/m3= densite de l'eau
+  ! 0.75e-3 = 3/4 /1000
+  ! Par la suite, I est tout le temps multiplie par sig_d pour avoir l'impaction sur la surface de la maille
+  ! on le neglige ici pour simplifier le code
+
+  DO j=1,klev-1
+     DO i=1,klon
+        imp(i,j) = coefcoli_3d(i,j)*0.75e-3/rdrop *&
+             0.5*(pmflxr(i,j+1)+pmflxs(i,j+1)+pmflxr(i,j)+pmflxs(i,j))
+     ENDDO
+  ENDDO
+!>jyg
   ! =========================================
   ! calcul des tendances liees au downdraft
Index: LMDZ5/branches/testing/libf/phylmd/declare_STDlev.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/declare_STDlev.h	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/declare_STDlev.h	(revision 2298)
@@ -57,5 +57,5 @@
       REAL zx_tmp_fiNC(klon,nlevSTD)
 
-      REAL missing_val
+!     REAL missing_val
       REAL, SAVE :: freq_moyNMC(nout)
 !$OMP THREADPRIVATE(freq_moyNMC)
Index: LMDZ5/branches/testing/libf/phylmd/dyn1d/1D_decl_cases.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/dyn1d/1D_decl_cases.h	(revision 2298)
+++ LMDZ5/branches/testing/libf/phylmd/dyn1d/1D_decl_cases.h	(revision 2298)
@@ -0,0 +1,254 @@
+#include "netcdf.inc"
+
+! Declarations specifiques au cas Toga
+        character*80 :: fich_toga
+!        integer nlev_prof
+!        parameter (nlev_prof = 41)
+        integer nlev_toga, nt_toga
+        parameter (nlev_toga=41, nt_toga=480)
+        integer year_ini_toga, day_ini_toga, mth_ini_toga
+        real day_ju_ini_toga   ! Julian day of toga coare first day
+        parameter (year_ini_toga=1992) 
+        parameter (mth_ini_toga=11)
+        parameter (day_ini_toga=1)  !  1erNov1992
+        real dt_toga
+        parameter (dt_toga=6.*3600.)
+!!
+        integer year_print, month_print, day_print
+        real    sec_print
+!!
+        real ts_toga(nt_toga)
+        real plev_toga(nlev_toga,nt_toga),w_toga(nlev_toga,nt_toga)
+        real t_toga(nlev_toga,nt_toga),q_toga(nlev_toga,nt_toga)
+        real u_toga(nlev_toga,nt_toga),v_toga(nlev_toga,nt_toga)
+        real ht_toga(nlev_toga,nt_toga),vt_toga(nlev_toga,nt_toga)
+        real hq_toga(nlev_toga,nt_toga),vq_toga(nlev_toga,nt_toga)
+
+        real ts_prof
+        real plev_prof(nlev_toga),w_prof(nlev_toga)
+        real t_prof(nlev_toga),q_prof(nlev_toga)
+        real u_prof(nlev_toga),v_prof(nlev_toga)
+        real ht_prof(nlev_toga),vt_prof(nlev_toga)
+        real hq_prof(nlev_toga),vq_prof(nlev_toga)
+
+        real w_mod(llm), t_mod(llm),q_mod(llm)
+        real u_mod(llm),v_mod(llm), ht_mod(llm),vt_mod(llm)
+        real hq_mod(llm),vq_mod(llm),qv_mod(llm),ql_mod(llm),qt_mod(llm)
+        real th_mod(llm)
+
+        real ts_cur
+        common /sst_forcing/ts_cur ! also in read_tsurf1d.F
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Declarations specifiques au cas RICO
+        character*80 :: fich_rico
+        integer nlev_rico
+
+        parameter (nlev_rico=81)
+        real ts_rico,ps_rico
+        real w_rico(llm)
+        real t_rico(llm),q_rico(llm)
+        real u_rico(llm),v_rico(llm)
+        real dth_rico(llm)
+        real dqh_rico(llm)
+        real du_age(llm),dv_age(llm)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Declarations specifiques au cas TWPice
+        character*80 :: fich_twpice
+        integer nlev_twpi, nt_twpi
+        parameter (nlev_twpi=40, nt_twpi=215)
+        integer year_ini_twpi, day_ini_twpi, mth_ini_twpi
+        real heure_ini_twpi
+        real day_ju_ini_twpi   ! Julian day of twpice first day
+        parameter (year_ini_twpi=2006) 
+        parameter (mth_ini_twpi=1)
+        parameter (day_ini_twpi=17)  ! 17 = 17Jan2006
+        parameter (heure_ini_twpi=10800.) !3h en secondes
+        real dt_twpi
+        parameter (dt_twpi=3.*3600.)
+
+        real ts_twpi(nt_twpi)
+        real plev_twpi(nlev_twpi,nt_twpi),w_twpi(nlev_twpi,nt_twpi)
+        real t_twpi(nlev_twpi,nt_twpi),q_twpi(nlev_twpi,nt_twpi)
+        real u_twpi(nlev_twpi,nt_twpi),v_twpi(nlev_twpi,nt_twpi)
+        real ht_twpi(nlev_twpi,nt_twpi),vt_twpi(nlev_twpi,nt_twpi)
+        real hq_twpi(nlev_twpi,nt_twpi),vq_twpi(nlev_twpi,nt_twpi)
+
+        real ts_proftwp
+        real plev_proftwp(nlev_twpi),w_proftwp(nlev_twpi)
+        real t_proftwp(nlev_twpi),q_proftwp(nlev_twpi)
+        real u_proftwp(nlev_twpi),v_proftwp(nlev_twpi)
+        real ht_proftwp(nlev_twpi),vt_proftwp(nlev_twpi)
+        real hq_proftwp(nlev_twpi),vq_proftwp(nlev_twpi)
+
+
+
+!Declarations specifiques au cas FIRE
+        character*80 :: fich_fire
+        integer nlev_fire, nt_fire
+        parameter (nlev_fire=120, nt_fire=1)  
+        integer year_ini_fire, day_ini_fire, mth_ini_fire
+        real heure_ini_fire
+        parameter (year_ini_fire=1987) 
+        parameter (mth_ini_fire=7)
+        parameter (day_ini_fire=14)  ! 14 = 14Juil1987
+        parameter (heure_ini_fire=0.) !0h en secondes
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!Declarations specifiques au cas DICE     (MPL 02072013)
+        character*80 :: fich_dice
+        integer nlev_dice, nt_dice
+        parameter (nlev_dice=70, nt_dice=145)  
+        integer year_ini_dice, day_ini_dice, mth_ini_dice
+        real heure_ini_dice
+        real day_ju_ini_dice   ! Julian day of dice first day
+        parameter (year_ini_dice=1999) 
+        parameter (mth_ini_dice=10)
+        parameter (day_ini_dice=23)  ! 23 = 23 october 1999
+        parameter (heure_ini_dice=68400.) !19UTC en secondes
+        real dt_dice
+        parameter (dt_dice=0.5*3600.) ! 1 forcage ttes les demi-heures
+
+!profils initiaux:
+        real plev_dice(nlev_dice)
+        
+        real zz_dice(nlev_dice)
+        real th_dice(nlev_dice),qv_dice(nlev_dice)
+        real u_dice(nlev_dice), v_dice(nlev_dice),o3_dice(nlev_dice)
+        real ht_dice(nlev_dice,nt_dice)
+        real hq_dice(nlev_dice,nt_dice), hu_dice(nlev_dice,nt_dice)
+        real hv_dice(nlev_dice,nt_dice)
+        real w_dice(nlev_dice,nt_dice),omega_dice(nlev_dice,nt_dice)
+        real o3_mod(llm),hu_mod(llm),hv_mod(llm)
+        real th_dicei(nlev_dice),qv_dicei(nlev_dice)
+        real u_dicei(nlev_dice), v_dicei(nlev_dice),o3_dicei(nlev_dice)
+        real ht_dicei(nlev_dice)
+        real hq_dicei(nlev_dice), hu_dicei(nlev_dice)
+        real hv_dicei(nlev_dice)
+        real w_dicei(nlev_dice),omega_dicei(nlev_dice)
+
+        
+!forcings
+        real shf_dice(nt_dice),lhf_dice(nt_dice)
+        real lwup_dice(nt_dice),swup_dice(nt_dice)
+        real tg_dice(nt_dice),ustar_dice(nt_dice),psurf_dice(nt_dice)
+        real ug_dice(nt_dice),vg_dice(nt_dice)
+
+        real shf_prof,lhf_prof,lwup_prof,swup_prof,tg_prof
+        real ustar_prof,psurf_prof,cdrag
+        real ht_profd(nlev_dice),hq_profd(nlev_dice),hu_profd(nlev_dice)
+        real hv_profd(nlev_dice),w_profd(nlev_dice)
+        real omega_profd(nlev_dice),ug_profd,vg_profd
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Declarations specifiques au cas GCSSold
+        character*80 :: fich_gcssold_ctl
+        character*80 :: fich_gcssold_dat
+        real  ht_gcssold(llm),hq_gcssold(llm),hw_gcssold(llm)
+        real  hu_gcssold(llm)
+        real  hv_gcssold(llm)
+        real  hthturb_gcssold(llm)
+        real  hqturb_gcssold(llm)
+        real  Ts_gcssold
+        real  dtime_frcg
+        logical :: Turb_fcg_gcssold
+
+        common /turb_forcing/                                                   &
+     &  dtime_frcg,hthturb_gcssold, hqturb_gcssold,Turb_fcg_gcssold
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Declarations specifiques au cas Arm_cu
+        character*80 :: fich_armcu
+
+
+        integer nlev_armcu, nt_armcu
+        parameter (nlev_armcu=40, nt_armcu=31)
+        integer year_ini_armcu, day_ini_armcu, mth_ini_armcu
+        real  heure_ini_armcu
+        real day_ju_ini_armcu                                ! Julian day of armcu case first day
+        parameter (year_ini_armcu=1997) 
+        parameter (mth_ini_armcu=6)
+        parameter (day_ini_armcu=21)  ! 172 = 21 juin 1997
+        parameter (heure_ini_armcu=41400)   ! 11:30 en secondes
+        real dt_armcu
+        parameter (dt_armcu=1.*1800.)   ! forcages donnes ttes les demi-heures par ifa_armcu.txt
+        real sens_armcu(nt_armcu),flat_armcu(nt_armcu)
+        real adv_theta_armcu(nt_armcu),rad_theta_armcu(nt_armcu)
+        real adv_qt_armcu(nt_armcu)
+        real theta_mod(llm),rv_mod(llm),play_mod(llm)
+! profc comme "profil armcu"
+        
+! forcages interpoles dans le temps
+        real adv_theta_prof,rad_theta_prof,adv_qt_prof
+        real sens_prof,flat_prof,fact
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! declarations specifiques au cas Sandu
+        character*80 :: fich_sandu
+!        integer nlev_prof
+!        parameter (nlev_prof = 41)
+        integer nlev_sandu, nt_sandu
+        parameter (nlev_sandu=87, nt_sandu=13)
+        integer year_ini_sandu, day_ini_sandu, mth_ini_sandu
+        real day_ju_ini_sandu                                ! Julian day of sandu case first day
+        parameter (year_ini_sandu=2006)
+        parameter (mth_ini_sandu=7)
+        parameter (day_ini_sandu=15)  ! 196 = 15 juillet 2006
+        real dt_sandu, tau_sandu
+        logical  :: trouve_700=.true.
+        parameter (dt_sandu=6.*3600.)   ! forcages donnes ttes les 6 heures par ifa_sandu.txt
+        parameter (tau_sandu=3600.)  ! temps de relaxation u,v,thetal,qt vers profil init et au dessus 700hPa
+!!
+        real ts_sandu(nt_sandu)
+! profs comme "profil sandu"
+        real plev_profs(nlev_sandu)
+        real t_profs(nlev_sandu),thl_profs(nlev_sandu)
+        real q_profs(nlev_sandu)
+        real u_profs(nlev_sandu),v_profs(nlev_sandu),w_profs(nlev_sandu)
+        real omega_profs(nlev_sandu),o3mmr_profs(nlev_sandu)
+
+        real, dimension(llm) :: relax_u,relax_v,relax_thl
+        real, dimension(llm,2) :: relax_q
+
+        real thl_mod(llm),omega_mod(llm),o3mmr_mod(llm),tke_mod(llm)
+!vertical advection computation
+        real d_t_z(llm), d_q_z(llm)
+        real d_t_dyn_z(llm), d_q_dyn_z(llm)
+        real d_u_z(llm),d_v_z(llm)
+        real d_u_dyn(llm),d_v_dyn(llm)
+        real d_u_dyn_z(llm),d_v_dyn_z(llm)
+        real d_u_adv(llm),d_v_adv(llm)
+        real zz(llm)
+        real zfact
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Declarations specifiques au cas Astex
+        character*80 :: fich_astex
+        integer nlev_astex, nt_astex
+        parameter (nlev_astex=34, nt_astex=49)
+        integer year_ini_astex, day_ini_astex, mth_ini_astex
+        real day_ju_ini_astex                                ! Julian day of astex case first day
+        parameter (year_ini_astex=1992)
+        parameter (mth_ini_astex=6)
+        parameter (day_ini_astex=13)  ! 165 = 13 juin 1992
+        real dt_astex
+        parameter (dt_astex=3600.)    ! forcages donnes ttes les heures par ifa_astex.txt
+        real ts_astex(nt_astex),div_astex(nt_astex),ug_astex(nt_astex)
+        real vg_astex(nt_astex),ufa_astex(nt_astex),vfa_astex(nt_astex)
+        real div_prof,ug_prof,vg_prof,ufa_prof,vfa_prof
+! profa comme "profil astex"
+        real plev_profa(nlev_astex)
+        real t_profa(nlev_astex),thl_profa(nlev_astex)
+        real qv_profa(nlev_astex),ql_profa(nlev_astex)
+        real qt_profa(nlev_astex),o3mmr_profa(nlev_astex)
+        real u_profa(nlev_astex),v_profa(nlev_astex),w_profa(nlev_astex)
+        real tke_profa(nlev_astex)
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!Declarations specifiques au cas standard
+
+        real w_mod_cas(llm), t_mod_cas(llm),q_mod_cas(llm)
+        real ug_mod_cas(llm),vg_mod_cas(llm)
+        real u_mod_cas(llm),v_mod_cas(llm)
+        real ht_mod_cas(llm),vt_mod_cas(llm),dt_mod_cas(llm),dtrad_mod_cas(llm)
+        real hq_mod_cas(llm),vq_mod_cas(llm),dq_mod_cas(llm)
+        real hu_mod_cas(llm),vu_mod_cas(llm),du_mod_cas(llm)
+        real hv_mod_cas(llm),vv_mod_cas(llm),dv_mod_cas(llm)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
